<template>
  <div class="menus-wrapper">
    <modal v-if="showMenuModal" @close="showMenuModal = false">
      <div class="menus-container">
        <img
          class="menu-image img-fluid"
          :src="image"
          v-for="image in responsiveMenuLG"
        />
      </div>
    </modal>
    <div class="menu-list-container">
      <div
        ref="menu"
        class="menu-list text-center pointer"
        @click="launchMenuModal"
        @scroll="onScroll"
      >
        <div
          class="menu-item"
          v-for="(image, index) in responsiveMenu"
          :ref="'menu-' + index"
        >
          <img class="menu-image img-fluid" :src="image" @load="menuLoaded" />
        </div>
      </div>
    </div>

    <div class="menu-nav-list-container">
      <div ref="nav" class="menu-nav-list">
        <div
          class="menu-nav-item"
          v-for="(image, index) in responsiveMenu"
          @click="() => selectMenu(index)"
          :class="{
            'is-nav-selected is-selected': selectedMenuIndex === index
          }"
        >
          <img @click="menuChoose" class="menu-image img-fluid" :src="image" />
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState } from "vuex";
import Modal from "@/components/Modal";

export default {
  components: {
    Modal
  },
  props: {
    restaurant: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      showMenuModal: false,
      selectedMenuIndex: null,
      observer: null
    };
  },
  computed: {
    ...mapState(["isMobile"]),
    menuImages() {
      return this.restaurant.menus;
    },
    responsiveMenu() {
      let operation;
      if (this.isMobile) {
        operation = "?fit=clip&w=800";
      } else {
        operation = "?fit=clip&w=1000";
      }
      return this.menuImages.map(m => `${m}${operation}`);
    },
    responsiveMenuLG() {
      let operation;
      if (this.isMobile) {
        operation = "?fit=clip&w=800";
      } else {
        operation = "?fit=clip&w=1400";
      }
      return this.menuImages.map(m => `${m}${operation}`);
    }
  },
  methods: {
    launchMenuModal() {
      this.showMenuModal = true;
      window.gtag("event", "Menu - Open", {
        event_label: JSON.stringify({ ...this.restaurant.dataForMixpanel })
      });
    },
    menuChoose() {
      window.gtag("event", "Menu - Choose", {
        event_label: JSON.stringify({ ...this.restaurant.dataForMixpanel })
      });
    },
    menuLoaded() {
      this.updateMenuBoxSize();
    },
    selectMenu(index, smooth = true) {
      this.selectedMenuIndex = index;
      const box = this.$refs.menu;
      const elem = this.$refs[`menu-${index}`][0];
      box.scrollTo({
        top: 0,
        left: elem.offsetLeft,
        behavior: smooth ? "smooth" : "auto"
      });
    },
    onScroll() {
      if (this.$refs.menu) {
        if (this.scrollTimer) {
          clearTimeout(this.scrollTimer);
        }

        this.scrollTimer = setTimeout(() => {
          this.scrollTimer = null;
          const box = this.$refs.menu;
          let menu = null;
          const scrollPos = box.scrollLeft;
          for (let i = 0; i < this.responsiveMenu.length; ++i) {
            const elem = this.$refs[`menu-${i}`];
            if (!elem) continue;
            const elemPos = elem[0].offsetLeft;
            if (scrollPos > elemPos - 15 && scrollPos < elemPos + 15) {
              menu = i;
              break;
            }
          }
          if (menu !== this.selectedMenuIndex && menu !== null) {
            this.selectMenu(menu);
            this.updateMenuBoxSize();
          }
        }, 100);
      }
    },
    updateMenuBoxSize() {
      if (!this.responsiveMenu || !this.responsiveMenu.length) return false;
      this.selectedMenuIndex = this.selectedMenuIndex || 0;
      const elem = this.$refs[`menu-${this.selectedMenuIndex}`];
      const container = document.querySelector(".menu-list-container");
      if (!container || !elem) return false;
      container.style.height = `${elem[0].querySelector("img").offsetHeight}px`;
      return true;
    }
  },
  updated() {
    this.updateMenuBoxSize();
  },
  mounted() {
    this.updateMenuBoxSize();
    this.observer = new ResizeObserver(entries => {
      if (this.resizeTimer) {
        clearTimeout(this.resizeTimer);
      }
      this.resizeTimer = setTimeout(() => {
        this.resizeTimer = null;
        this.selectMenu(this.selectedMenuIndex, false);
        this.updateMenuBoxSize();
      }, 100);
    });
    const wrapper = document.querySelector(".menus-wrapper");
    if (wrapper) this.observer.observe(wrapper);
  },
  destroyed() {
    this.observer.disconnect();
    if (this.scrollTimer) {
      clearTimeout(this.scrollTimer);
      this.scrollTimer = null;
    }
  }
};
</script>
<style lang="scss" scoped>
.menu-item {
  width: 100%;
  flex-shrink: 0;
  position: relative;
  scroll-snap-align: start;
  margin-bottom: 30px;
}
.menu-nav-item {
  width: 16.66%;
  position: relative;
  cursor: pointer;

  &:before {
    content: "";
    position: absolute;
    left: 0;
    width: 100%;
    top: 0;
    height: 100%;
    pointer-events: none;
    background-color: rgba($color-primary-black, 0);
    transition: background-color 0.3s;
  }

  &.is-nav-selected:before {
    background-color: rgba($color-primary-black, 0.3);
  }

  & + & {
    margin-left: 3px;
  }
}
.menu-image {
}

.menu-list-container {
  overflow: hidden;
  border-bottom: 1px solid $color-sky-grey;
}

.menu-list {
  display: flex;
  flex-direction: row;
  overflow-x: scroll;
  overflow-y: hidden;
  -webkit-overflow-scrolling: touch;
  scroll-snap-type: both mandatory;
}

.menu-nav-list-container {
  overflow: hidden;
}

.menu-nav-list {
  padding: $grid-gutter-width/2;
  display: flex;
  flex-direction: row;
  justify-content: center;
  overflow-x: hidden;
  overflow-y: hidden;
  -webkit-overflow-scrolling: touch;
}

.menus-container {
  text-align: center;
  max-width: 1080px;
  margin: auto;
  .menu-image {
    display: block;
    width: 100%;
  }
}
</style>
